/*
 * Main.java
 *
 * Created on 27 mai 2009, 15:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package assignment2;
import java.util.LinkedList;
import java.util.Collections;
import java.util.Iterator;
/**
 *
 * @author Aqualonne
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        //polynomialTest();
        LinkedList<Integer> L1 = new LinkedList();
        LinkedList<Integer> L2 = new LinkedList();
        L1.add(1); L1.add(3); L1.add(5); L1.add(6);
        L2.add(2); L2.add(3); L2.add(4); L2.add(5);
        intersection(L1,L2);
    }
    
    public static void intersection(LinkedList L1, LinkedList L2){
        for(int i = 0; i<L1.size(); i++){//O(n): visiting each element of the list
            if(L2.contains(L1.get(i)))//O(n): searching in a LinkedList from start
                System.out.println(L1.get(i));
        }
        //The overall method is in O(n) for time, and O(1) for space
    }
    
    /***********************************************************************
     *                         Using sorting
     *
     * We sort the two lists, so 2 operations on O(n log n) yield O(n log n).
     * We denote by x1 and x2 the current element respectively of L1 and L2.
     * We go from x1 being the first one to the last one.
     *       If x1 == x2
     *             we show x1, since there is a match
     *             x1 and x2 move forward
     *       if x1 < x2
     *             x1 moves forward
     *       if x1 > x2
     *             x2 moves forward
     * This loop takes 3 comparisons in the worst case and will be executed n
     * times, hence 3n belongs to the class O(n).
     * Since O(n log n) is a greater class of complexity, it takes O(n log n).
     * This is similar to the merge function of a mergeSort that takes two lists.
     ************************************************************************/
    
    public static void polynomialTest(){
        Polynomial p = new Polynomial();
        p.add(-3,2);
        p.add(6,1);
        p.add(10,0);
        System.out.println("____10x^0 6x^1 -3x^2 ____");
        System.out.println(p);
        System.out.println("____Expecting 10x^0 -3x^2 ____");
        p.add(-6,1);
        System.out.println(p);
        System.out.println("Must be -290: "  + p.evaluate(10));
        System.out.println("-1 is reasonable :"  + p.estimateRoot(-30,30,1));
        System.out.println("Randomly generated polynomial: " + p.generates(4,10));
        Polynomial p2 = new Polynomial();
        p2.add(2,2);
        p2.add(3,3);
        System.out.println("Multiplied by " + p2 + ": " + p.multiply(p,p2));
    }
    
}
